/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.modele;

import com.google.gwt.json.client.JSONObject;
import com.lucsorel.hesperis.client.tools.JSONTools;

public class Utilisateur
{
	static private Utilisateur tU_utilisateur;
	private int ii_id;
	private String is_login;
	private String is_nom;
	private boolean ib_valide;

	private Utilisateur()
	{
		this.setValide( false );
	}

	static public Utilisateur Instance()
	{
		if( tU_utilisateur == null )
		{
			tU_utilisateur = new Utilisateur();
		}
		return tU_utilisateur;
	}

	/**
	 * @return the ii_id
	 */
	public int getId()
	{
		return this.ii_id;
	}
	/**
	 * @param pi_id the ii_id to set
	 */
	public void setId( int pi_id )
	{
		this.ii_id = pi_id;
	}

	/**
	 * @return the is_login
	 */
	public String getLogin()
	{
		return this.is_login;
	}
	/**
	 * @param ps_login the is_login to set
	 */
	public void setLogin( String ps_login )
	{
		this.is_login = ps_login;
	}

	/**
	 * @return the is_nom
	 */
	public String getNom()
	{
		return this.is_nom;
	}
	/**
	 * @param ps_nom the is_nom to set
	 */
	public void setNom( String ps_nom )
	{
		this.is_nom = ps_nom;
	}

	/**
	 * @return the ib_valide
	 */
	public boolean estValide()
	{
		return this.ib_valide;
	}
	/**
	 * @param pb_valide the ib_valide to set
	 */
	public void setValide( boolean pb_valide )
	{
		this.ib_valide = pb_valide;
	}

	/**
	 * Renseigne l'utilisateur avec une chaîne de caractères représentant un objet Uitlisateur au format JSON :
	 * {"Utilisateur":{"id":1, "login":"luc", "nom":"Luc Sorel"}}
	 * @param ps_jsonUtilisateur
	 * @return	boolean	true si l'utilisateur renseigné est valide
	 */
	public boolean enrichirSelonJson( String ps_jsonUtilisateur )
	{
		// réinitialisation de l'instance
		setId( 0 );
		setLogin( null );
		setNom( null );
		setValide( false );

		// enrichissement de l'utilisateur avec le flux s'il comporte la structure d'un Utilisateur
		JSONObject lJSO_utilisateur = JSONTools.ChaineEstJSONObject( ps_jsonUtilisateur, "Utilisateur" );
		if( lJSO_utilisateur != null )
		{
			// récupération des valeurs nécessaires dans l'objet JSON si les propriétés existent
			int li_id = JSONTools.ValeurProprieteEntiere( lJSO_utilisateur, "id" );
			String ls_login = JSONTools.ValeurProprieteTextuelle( lJSO_utilisateur, "login" );
			String ls_nom = JSONTools.ValeurProprieteTextuelle( lJSO_utilisateur, "nom" );

			// validation des valeurs retrouvées et enrichissement
			if( (li_id >= 0) && (ls_login.length() > 0) && (ls_nom.length() > 0) )
			{
				this.setId( li_id );
				this.setLogin( ls_login );
				this.setNom( ls_nom );
				this.setValide( true );
			}
		}

		return estValide();
	}

	/**
	 * 
	 */
	public void reinitialiser()
	{
		setId( 0 );
		setLogin( null );
		setNom( null );
		setValide( false );
	}

	public String toString()
	{
		String ls_utilisateur = "Utilisateur{id:" + getId() + ", login:'" + getLogin() + "', nom:'" + getNom() 
		+ "', " + ( estValide() ? "valide" : "invalide" ) + "}";
		return ls_utilisateur;
	}
}