/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.ajax;

import org.enunes.gwt.mvp.client.EventBus;

import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.RequestCallback;
import com.google.gwt.http.client.Response;
import com.lucsorel.hesperis.client.event.AfficherConnexionEvent;
import com.lucsorel.hesperis.client.event.MessageEvent;
import com.lucsorel.hesperis.client.modele.Erreur;
import com.lucsorel.hesperis.client.modele.Message;

public class DeconnexionRequestCallback implements RequestCallback
{
	static private DeconnexionRequestCallback tCB_deconnexionCallback;

	final private EventBus iEB_eventBus;

	/**
	 * Le gestionnaire de retour de la requête de déconnexion connaît le bus d'événement
	 * @param pEB_eventBus
	 */
	private DeconnexionRequestCallback( EventBus pEB_eventBus )
	{
		iEB_eventBus = pEB_eventBus;
	}

	static public DeconnexionRequestCallback Instance( EventBus pEB_eventBus )
	{
		if( tCB_deconnexionCallback == null )
		{
			tCB_deconnexionCallback = new DeconnexionRequestCallback( pEB_eventBus );
		}
		return tCB_deconnexionCallback;
	}

	/*************************************************
	 * Méthodes de gestion de retour de requête ajax *
	 *************************************************/

	@Override
	public void onError( Request request, Throwable pRE_exception )
	{
		iEB_eventBus.fireEvent( new MessageEvent(
				new Erreur( "Requête de connexion erronnée :\n" + pRE_exception.getMessage())
		) );
	}
	@Override
	public void onResponseReceived( Request request, Response pR_retourDeconnexion )
	{
		// gestion des erreurs
		String ls_texteReponse = pR_retourDeconnexion.getText();
		boolean lb_deconnexion = ls_texteReponse.equals( "true" );
		Message lM_message = null;

		// affichage d'un message d'erreur si la déconnexion a échouée
		if( ! lb_deconnexion )
		{
			if( pR_retourDeconnexion.getStatusCode() != Response.SC_OK )
			{
				lM_message = new Erreur( "Erreur : " + pR_retourDeconnexion.getStatusText()
						+ "\n Code : " + pR_retourDeconnexion.getStatusCode()
						+ "\n Header : [" + pR_retourDeconnexion.getHeadersAsString() + "]" );
			}
			// affichage du message d'erreur
			else
			{
				lM_message = new Erreur( ls_texteReponse );
			}
			iEB_eventBus.fireEvent( new MessageEvent(lM_message) );
		}
		// redirection sur la page de connexion si la déconnexion a été validée
		else
		{
			// Affichage de la connexion
			iEB_eventBus.fireEvent( new AfficherConnexionEvent() );
		}
	}

}
