/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.event;

import com.google.gwt.event.shared.GwtEvent;

public class DemandeDeconnexionEvent extends GwtEvent<DemandeDeconnexionHandler>
{
	private static Type<DemandeDeconnexionHandler> TYPE;
	private final int ii_timeOutMilliSecondes;
	/**
	 * Constructeur de DemandeConnexionEvent
	 */
	public DemandeDeconnexionEvent()
	{
		ii_timeOutMilliSecondes = 0;
	}
	
	/**
	 * @param pi_timeOutMilliSecondes
	 */
	public DemandeDeconnexionEvent( int pi_timeOutMilliSecondes )
	{
		if( pi_timeOutMilliSecondes < 0 )
		{
			ii_timeOutMilliSecondes = 0;
		}
		else
		{
			ii_timeOutMilliSecondes = pi_timeOutMilliSecondes;
		}
	}

	/**
	 * @return the ii_timeOutMilliSecondes
	 */
	public int getTimeOutMilliSecondes()
	{
		return ii_timeOutMilliSecondes;
	}

	/*
	 * Méthodes requises pour l'association avec le gestionnaire d'événements
	 */
	public static Type<DemandeDeconnexionHandler> getType()
	{
		return (TYPE != null) ? TYPE : (TYPE = new Type<DemandeDeconnexionHandler>());
	}
	@Override
	public final Type<DemandeDeconnexionHandler> getAssociatedType()
	{
		return getType();
	}
	@Override
	protected void dispatch( DemandeDeconnexionHandler pH_handler )
	{
		pH_handler.onDemandeDeconnexion( this );
	}
}