/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.gin;

import com.google.gwt.inject.client.AbstractGinModule;
import com.lucsorel.hesperis.client.presview.ConnexionDisplay;
import com.lucsorel.hesperis.client.presview.ConnexionPresenter;
import com.lucsorel.hesperis.client.presview.DeconnexionDisplay;
import com.lucsorel.hesperis.client.presview.DeconnexionPresenter;
import com.lucsorel.hesperis.client.presview.HesperisMvpDisplay;
import com.lucsorel.hesperis.client.presview.HesperisMvpPresenter;
import com.lucsorel.hesperis.client.presview.IConnexion;
import com.lucsorel.hesperis.client.presview.IDeconnexion;
import com.lucsorel.hesperis.client.presview.IHesperisMvp;
import com.lucsorel.hesperis.client.presview.IMessage;
import com.lucsorel.hesperis.client.presview.MessageDisplay;
import com.lucsorel.hesperis.client.presview.MessagePresenter;

public class HesperisMvpModule extends AbstractGinModule
{
	@Override
	protected void configure()
	{
		// injection des dépendances relatives au bus d'événements
		install( new org.enunes.gwt.mvp.client.gin.Module() );
		
		/*
		 * Relie chaque interface :
		 * - de présenteur (IXxxPresenter) à son implémentation (XxxPresenter)
		 * - de vue (IXxxPresenter.Display) à son implémentation (XxxDisplay)
		 */
		// le présenteur générique de l'application
		bind( IHesperisMvp.class ).to( HesperisMvpPresenter.class );
		bind( IHesperisMvp.Display.class ).to( HesperisMvpDisplay.class );

		// le présenteur de connexion
		bind( IConnexion.class ).to( ConnexionPresenter.class );
		bind( IConnexion.Display.class ).to( ConnexionDisplay.class );

		// le présenteur chargé d'afficher les messages
		bind( IMessage.class ).to( MessagePresenter.class );
		bind( IMessage.Display.class ).to( MessageDisplay.class );
		
		// le présenteur de déconnexion
		bind( IDeconnexion.class ).to( DeconnexionPresenter.class );
		bind( IDeconnexion.Display.class ).to( DeconnexionDisplay.class );
	}
}