/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.presview;

import org.enunes.gwt.mvp.client.presenter.Presenter;

import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.user.client.ui.HasText;

/**
 * Interface du tandem Présenter-Vue relatif à la déconnexion de l'utilisateur
 */
public interface IDeconnexion extends Presenter<IDeconnexion.Display>
{
	interface Display extends org.enunes.gwt.mvp.client.view.Display
	{
		/*
		 * Exposition des méthodes de la Vue associée au présenteur DeconnexionPresenter renvoyant des 
		 * éléments de la Vue castés par le type de handler gérant les événements de ces éléments
		 */

		/**
		 * Renvoie le label de login à travers l'interface de gestion de texte
		 * @return	HasText
		 */
		public HasText getLoginTexte();

		/**
		 * Renvoie le label de nom à travers l'interface de gestion de texte
		 * @return	HasText
		 */
		public HasText getNomTexte();

		/**
		 * Renvoie le bouton de déconnexion à travers l'interface de gestion de clic
		 * @return	HasClickHandlers
		 */
		public HasClickHandlers getDeconnexionClickHandlers();

		/**
		 * Ajoute la vue du module d'affichage des messages dans le widget général de déconnexion
		 * @param display	le widget d'affichage des messages
		 */
		void ajouterMessageDisplay( IMessage.Display display );
	}
	
	/*
	 * Exposition des méthodes exposées du présenteur DeconnexionPresenter de manipulation
	 * des objets métiers et de la vue, pouvant être appelées par d'autres Présenteurs
	 */
	/**
	 * Affiche l'utilisateur dans la vue
	 */
	public void afficherUtilisateur();
}