/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.presview;

import org.enunes.gwt.mvp.client.presenter.Presenter;

/**
 * Interface du tandem Présenter-Vue général de l'application 
 */
public interface IHesperisMvp extends Presenter<IHesperisMvp.Display>
{
	interface Display extends org.enunes.gwt.mvp.client.view.Display
	{
		/*
		 * Exposition des méthodes de la Vue associée au présenteur HesperisMvpMain renvoyant des 
		 * éléments de la Vue castés par le type de handler gérant les événements de ces éléments
		 */
		/**
		 * Vide la vue de connexion ou de déconnexion
		 */
		public void viderConnexionDeconnexion();

		/**
		 * Ajoute la vue de connexion ou de déconnexion dans le conteneur approprié
		 */
		public void afficherConnexionDeconnexion( org.enunes.gwt.mvp.client.view.Display pD_display );
	}
	
	/*
	 * Exposition des méthodes exposées du présenteur HesperisMvpMain de manipulation
	 * des objets métiers et de la vue, pouvant être appelées par d'autres Présenteurs
	 */
	
}