/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.presview;

import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Widget;
import com.lucsorel.hesperis.client.presview.IMessage.Display;

public class MessageDisplay extends Composite implements Display
{
	/**
	 * Déclaration des éléments graphiques composant la vue, et qui pourront être renvoyés 
	 * par le widget sous forme de ...HasHandlers. Ces méthodes typées ...HasHandler doivent
	 * être déclarées dans l'interface IMessage associée.
	 */
	// Panneau englobant le widget (permet une initialisation du widget dans le constructeur)
	final private HTML iH_message;
	
	/**
	 * Le module GIN a besoin d'un constructeur sans paramètre 
	 * pour pouvoir faire de l'injection de dépendances.
	 */
	public MessageDisplay()
	{
		iH_message = new HTML();
		iH_message.setStylePrimaryName( "message" );
		
		// définit "iH_message" comme étant le composant graphique représentant cette classe
		initWidget( iH_message );
	}
	
	/**
	 * Méthode surchargée pour l'implémentation du pattern MVP
	 * @see org.enunes.gwt.mvp.client.view.Display#asWidget()
	 */
	@Override
	public Widget asWidget()
	{
		return this;
	}

	/**
	 * Renvoie le panneau d'affichage des messages
	 * @see com.lucsorel.hesperis.client.presview.IMessage.Display#getHtmlMessage()
	 */
	@Override
	public HTML getHtmlMessage()
	{
		return this.iH_message;
	}
}