/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

package com.lucsorel.hesperis.client.presview;

import com.lucsorel.hesperis.client.event.MessageEvent;
import com.lucsorel.hesperis.client.event.MessageHandler;
import com.lucsorel.hesperis.client.modele.Erreur;
import com.lucsorel.hesperis.client.modele.Message;
import com.lucsorel.hesperis.client.modele.Warning;
import com.lucsorel.hesperis.client.presview.IMessage.Display;

import org.enunes.gwt.mvp.client.EventBus;
import org.enunes.gwt.mvp.client.presenter.BasePresenter;

import com.google.gwt.user.client.ui.HTML;
import com.google.inject.Inject;

public class MessagePresenter extends BasePresenter<Display> implements IMessage
{
	@Inject
	public MessagePresenter( EventBus pEB_eventBus, Display pD_display )
	{
		super( pEB_eventBus, pD_display );
	}
	
	/*
	 * Crée les associations de base entre la vue et le présenteur
	 */
	@Override
	public void bind()
	{
		super.bind();
		
		/******************************************************************\
		 * Traitement des événements "métier" envoyés au bus d'événements *
		\******************************************************************/
		/**
		 * Capte les événements d'affichage de message
		 */
		registerHandler( eventBus.addHandler(MessageEvent.getType(),
				new MessageHandler() {
					@Override
					public void onMessage(MessageEvent pE_message) {
						doAfficherMessage( pE_message );
					}
		}) );
	}

	/**
	 * Affiche le message
	 * @param pE_message 
	 */
	protected void doAfficherMessage( MessageEvent pE_message )
	{
		Message pM_message = pE_message.getMessage();
		HTML lH_message = display.getHtmlMessage();
		if( pM_message instanceof Erreur )
		{
			lH_message.setStylePrimaryName( "message-erreur" );
			lH_message.setHTML( pM_message.getMessage() );
		}
		else if( pM_message instanceof Warning )
		{
			lH_message.setStylePrimaryName( "message-warning" );
			lH_message.setHTML( pM_message.getMessage() );
		}
		// nettoyage du stylage, affichage du message
		else if( pM_message != null )
		{
			lH_message.setStylePrimaryName( "message" );
			lH_message.setHTML( pM_message.getMessage() );
		}
		// nettoyage du stylage et du message
		else
		{
			lH_message.setStylePrimaryName( "message" );
			lH_message.setHTML( "" );
		}

	}
}