<?php
/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */


/* La classe Controleur sollicitée par l'application doit :
 * - implémenter la fonction traiter_requet() permettant de traiter les requêtes HTTP suivantes :
 *   - action=connecter&login=xxx&password=yyy et renvoyer les infos "utilisateur" sous la forme
 *     {"Utilisateur":{"id":1, "login":"luc", "nom":"Luc Sorel"}}
 *   - action=deconnecter et renvoyer "true"
 * - en cas d'erreur (connexion ou déconnexion), envoyer une exception qui sera transformée 
 *   par la méthode Controleur::lancer_erreur_json() en un message JSON de la forme :
 *   {"Erreur":{"message":"message d'erreur explicatif"}}
 */
require_once( 'php/Controleur.inc' );

// Démarrage de la session
session_start();

// Traitement de la requête par le contrôleur Hespéris côté serveur
// instanciation du contrôleur singleton
$gC_controleur = Controleur::Instance();
try
{
	$gC_controleur->traiter_requete();
}
// transformation des éventuelles exceptions en messages JSON
catch( Exception $le_exception )
{
	$gC_controleur->lancer_erreur_json( $le_exception->getMessage() );
}