<?php
/**
 * Moi (Luc Sorel, http://www.lucsorel.com/index.php?page=contact) reconnaît être l'auteur de ce code source. 
 * J'ai placé ce code source dans le domaine publique. Vous pouvez utiliser, modifier et distribuer le code 
 * source et les programmes exécutables basés sur ce code source. Veuillez toutefois prendre en considération 
 * les points suivants :
 * 
 * --- Décharge légale de garantie ---
 * Ce code source vous est présenté "en tant que tel" et sans garantie de performance ou d'intérêt commercial. 
 * L'auteur et / ou le distributeur ont pu faire des déclarations ) propos de ce code source. Ces déclarations 
 * n'ont pas valeur de garanties et ne doivent pas servir de fondements quant à l'utilisation tierce de ce code 
 * source.
 * 
 * Ce code source est mis à disposition sans aucune garantie implicite ou explicite. Étant donné la diversité 
 * des conditions contextuelles et matérielles sous lesquelles ce code source peut être utilisé, aucune garantie 
 * d'adéquation pour un usage spécifique n'est proposé. il est conseillé que l'utilisateur teste le code source 
 * consciencieusement avant de s'appuyer dessus. L'utilisateur prend l'entière responsabilité de l'utilisation 
 * de ce code source.
 */

require_once( 'JSONTools.inc' );

class Utilisateur
{
	/* Tableaux des utilisateurs simulant des enregistrements dans une base de données :
	 * - login : luc ; mot de passe : luc
	 * - login : frederic ; mot de passe : frederic
	 */
	static private $tsa_utilisateurs = array(
		'1'=>array('login'=>'luc', 'password_crypte'=>'3d2abc32a1545b717873ef149ff9cb24', 'nom'=>'Luc Sorel'),
		'2'=>array('login'=>'frederic', 'password_crypte'=>'952fae006ec02dceb9a4caf8ad1aeeb6', 'nom'=>'Frédéric Lehobey')
	);

	private $ii_id;
	private $is_login;
	private $is_password_crypte;
	private $is_nom;

	/**
	 * Constructeur de Utilisateur
	 */
	public function __construct()
	{}

	/**
	 * Renvoie l'identifiant de l'utilisateur
	 * @return	integer
	 */
	public function get_id()
	{
		return $this->ii_id;
	}
	/**
	 * Assigne l'identifiant de l'utilisateur
	 * @param	integer	$pi_id
	 */
	public function set_id( $pi_id )
	{
		$this->ii_id = $pi_id;
	}

	/**
	 * Renvoie le nom de compte de l'utilisateur (login)
	 * @return	string
	 */
	public function get_login()
	{
		return $this->is_login;
	}
	/**
	 * Assigne le nom de compte de l'utilisateur (login)
	 * @param	string	$ps_login
	 */
	public function set_login( $ps_login )
	{
		$this->is_login = $ps_login;
	}

	/**
	 * Renvoie le mot de passe crypté de l'utilisateur (préfixé de 'hesperis_' et md5)
	 * @return	string
	 */
	public function get_password_crypte()
	{
		return $this->is_password_crypte;
	}
	/**
	 * Assigne le mot de passe crypté de l'utilisateur (préfixé de 'hesperis_' et md5)
	 * @param	string	$ps_password_crypte
	 */
	public function set_password_crypte( $ps_password_crypte )
	{
		$this->is_password_crypte = $ps_password_crypte;
	}

	/**
	 * Renvoie le nom de l'utilisateur
	 * @return	string	le nom de l'utilisateur
	 */
	public function get_nom()
	{
		return $this->is_nom;
	}
	/**
	 * Assigne le nom de l'utilisateur
	 * @param	string	$ps_nom	le nom de l'utilisateur
	 */
	public function set_nom( $ps_nom )
	{
		$this->is_nom = $ps_nom;
	}

	/**
	 * Exporte l'Utilisateur au format JSON sous la forme :
	 * {"Utilisateur":{"id":1, "login":"luc", "nom":"Luc Sorel"}}
	 * 
	 * @return	string	l'Utilisateur linéarisé en JSON
	 */
	public function exporter_en_JSON()
	{
		$ls_json = '{"Utilisateur":{"id":' . $this->get_id() 
			. ', "login":' . JSONTools::Proteger_chaine_pour_JSON( $this->get_login() ) 
			. ', "nom":' . JSONTools::Proteger_chaine_pour_JSON( $this->get_nom() ) . '}}';

		return $ls_json;
	}

	/**********************
	 * METHODES STATIQUES *
	 **********************/

	/**
	 * Instancie un Utilisateur d'après son login et mot de passe
	 * @return	Utilisateur	l'Utilisateur correspondant au login et mot de passe crypté passés en paramètre, ou null
	 */
	static public function Instancier_selon_login_password_crypte( $ps_login, $ps_password_crypte )
	{
		$lU_utilisateur = null;
		foreach( self::$tsa_utilisateurs as $li_id=>$lma_proprietes )
		{
			if( ($lma_proprietes['login'] == $ps_login) 
			&& ($lma_proprietes['password_crypte'] == $ps_password_crypte) )
			{
				$lU_utilisateur = new Utilisateur();
				$lU_utilisateur->set_id( $li_id );
				$lU_utilisateur->set_login( $ps_login );
				$lU_utilisateur->set_password_crypte( $ps_password_crypte );
				$lU_utilisateur->set_nom( $lma_proprietes['nom'] );
				break;
			}
		}

		return $lU_utilisateur;
	}
}
